#include "iostream"
#include "stdlib.h"
#include "SDL/SDL.h"

#define SCREENX 640
#define SCREENY 480
#define PLAYERW 16
#define PLAYERH 24

using namespace std;
  
int main(){
SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER);
SDL_Surface* dis=SDL_SetVideoMode(SCREENX,SCREENY,16,SDL_FULLSCREEN|SDL_DOUBLEBUF);
SDL_Event game;
SDL_Rect playersprite,background;
Uint8* key;
int quit=0;
Uint8 r=255,g=255,b=255;
int currentTime,oldTime,framerate = 30, framemillisec;

int xp=80,yp=80;
int change_color=0,change_color_pressed=0;
  
//set the dimensions of the playersprite and backgorund window rectangle
background.x=0; background.y=0;
background.w=SCREENX; background.h=SCREENY;
playersprite.x=xp; playersprite.y=yp;
playersprite.w=PLAYERW; playersprite.h=PLAYERH;
  
srand(currentTime);             //seed random number generator

framemillisec = 1000/framerate; // calculate frame delay in milleseconds based on desired framerate 
oldTime=SDL_GetTicks(); 	//initialize first timestamp for framerate calculation

while (quit==0){                // main game loop
  SDL_PollEvent(&game);
  if (game.type == SDL_KEYDOWN) {
   key=SDL_GetKeyState(NULL);
   if(key[SDLK_q]){quit=1;}
   if(key[SDLK_a]){change_color=1;}else{change_color_pressed=0;}
   if(key[SDLK_UP]){yp-=3;}
   if(key[SDLK_DOWN]){yp+=3;}
   if(key[SDLK_LEFT]){xp-=3;}
   if(key[SDLK_RIGHT]){xp+=3;}
   if(xp<0){xp=0;}
   if(xp>SCREENX-PLAYERW){xp=SCREENX-PLAYERW;}
   if(yp<0){yp=0;}
   if(yp>SCREENY-PLAYERH){yp=SCREENY-PLAYERH;}
   playersprite.x=xp; playersprite.y=yp;

   if(change_color==1&&change_color_pressed==0){
     r=rand()%255; g=rand()%255; b=rand()%255;
     cout<<"R = "<<(int)r<<", G = "<<(int)g<<", B = "<<(int)b<<endl;
      change_color_pressed=1;
   }
   change_color=0;
  } // end if SDL_KEYDOWN
    
   // We currently redraw everything every frame : TODO: change only if changed
   SDL_FillRect(dis,&background,SDL_MapRGB(dis->format,0,0,0));// CLEAN THE SCREEN.
   SDL_FillRect(dis,&playersprite,SDL_MapRGB(dis->format,r,g,b)); // Draw player rectangle
   SDL_Flip(dis);

// Pause execution until next frame is finished
   currentTime=SDL_GetTicks();
   cout<<framemillisec-(currentTime-oldTime)<<", "<<currentTime<<", "<<oldTime<<endl; 
   if(currentTime-oldTime<framemillisec) {
     SDL_Delay(framemillisec-(currentTime-oldTime));
   } else
     cout<<"game too slow for desired framerate "<<framerate<<endl;
   
   oldTime=SDL_GetTicks();
}         // end main game loop

SDL_Quit();
return 0;
}
